<a name="g2"></a>

## g2 ⇒ <code>object</code>
g2.chart (c) 2015-18 Stefan Goessner

**Kind**: global typedef  
**Returns**: <code>object</code> - chart  
**Requires**: <code>module:g2.core.js</code>, <code>module:g2.ext.js</code>  
**Author**: Stefan Goessner  
**License**: MIT License  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | Chart arguments object or |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x | <code>float</code> |  | x-position of lower left corner of chart rectangle. |
| y | <code>float</code> |  | y-position of lower left corner of chart rectangle. |
| [b] | <code>float</code> | <code>150</code> | width of chart rectangle. |
| [h] | <code>float</code> | <code>100</code> | height of chart rectangle. |
| [ls] | <code>string</code> |  | border color. |
| [fs] | <code>string</code> |  | fill color. |
| [title] | <code>string</code> \| <code>object</code> |  | chart title. |
| [title.text] | <code>string</code> |  | chart title text string. |
| [title.offset] | <code>float</code> | <code>0</code> | chart title vertical offset. |
| [title.style] | <code>object</code> |  | chart title style. |
| [title.style.font] | <code>string</code> | <code>&quot;14px serif&quot;</code> | chart title font. |
| [title.style.thal] | <code>string</code> | <code>&quot;center&quot;</code> | chart title horizontal align. |
| [title.style.tval] | <code>string</code> | <code>&quot;bottom&quot;</code> | chart title vertical align. |
| [funcs] | <code>array</code> | <code>[]</code> | array of dataset `data` and/or function `fn` objects. |
| [funcs[item]] | <code>object</code> |  | dataset or function object. |
| [funcs[item].data] | <code>array</code> |  | data points as flat array `[x,y,..]`, array of point arrays `[[x,y],..]` or array of point objects `[{x,y},..]`. |
| [funcs[item].fn] | <code>function</code> |  | function `y = f(x)` recieving x-value returning y-value. |
| [funcs[item].dx] | <code>float</code> |  | x increment to apply to function `fn`. Ignored with data points. |
| [funcs[item].fill] | <code>boolean</code> |  | fill region between function graph and x-origin line. |
| [funcs[item].dots] | <code>boolean</code> |  | place circular dots at data points (Avoid with `fn`s). |
| [xaxis] | <code>boolean</code> \| <code>object</code> | <code>false</code> | x-axis. |
| [xaxis.grid] | <code>boolean</code> \| <code>object</code> | <code>false</code> | x-axis grid lines. |
| [xaxis.grid.ls] | <code>string</code> |  | x-axis grid line style (color). |
| [xaxis.grid.lw] | <code>string</code> |  | x-axis grid line width. |
| [xaxis.grid.ld] | <code>string</code> |  | x-axis grid line dash style. |
| [xaxis.line] | <code>boolean</code> | <code>true</code> | display x-axis base line. |
| [xaxis.origin] | <code>boolean</code> | <code>false</code> | display x-axis origin line. |
| [yaxis] | <code>boolean</code> \| <code>object</code> | <code>false</code> | y-axis. |
| [yaxis.grid] | <code>boolean</code> \| <code>object</code> | <code>false</code> | y-axis grid lines. |
| [yaxis.grid.ls] | <code>string</code> |  | y-axis grid line style color. |
| [yaxis.grid.lw] | <code>string</code> |  | y-axis grid line width. |
| [yaxis.grid.ld] | <code>string</code> |  | y-axis grid line dash style. |
| [yaxis.line] | <code>boolean</code> | <code>true</code> | display y-axis base line. |
| [yaxis.origin] | <code>boolean</code> | <code>false</code> | display y-axis origin line. |
| [xmin] | <code>float</code> |  | minimal x-axis value. If not given it is calculated from chart data values. |
| [xmax] | <code>float</code> |  | maximal x-axis value. If not given it is calculated from chart data values. |
| [ymin] | <code>float</code> |  | minimal y-axis value. If not given it is calculated from chart data values. |
| [ymax] | <code>float</code> |  | maximal y-axis value. If not given it is calculated from chart data values. |

