<a name="g2"></a>

## g2 ⇒ [<code>g2</code>](#g2)
Additional methods for g2.

**Kind**: global typedef  
**Requires**: <code>module:g2.core.js</code>  
**Author**: Stefan Goessner  
**License**: MIT License  

* [g2](#g2) ⇒ [<code>g2</code>](#g2)
    * _instance_
        * [.nod](#g2+nod)
            * [new g2.prototype.nod(args)](#new_g2+nod_new)
        * [.dblnod](#g2+dblnod)
            * [new g2.prototype.dblnod()](#new_g2+dblnod_new)
        * [.pol](#g2+pol)
            * [new g2.prototype.pol(args)](#new_g2+pol_new)
        * [.gnd](#g2+gnd)
            * [new g2.prototype.gnd(args)](#new_g2+gnd_new)
        * [.origin](#g2+origin)
            * [new g2.prototype.origin(args)](#new_g2+origin_new)
        * [.hdl(args)](#g2+hdl) ⇒ <code>object</code>
        * [.nodflt(args)](#g2+nodflt) ⇒ <code>object</code>
        * [.vec(args)](#g2+vec) ⇒ <code>object</code>
        * [.avec(args)](#g2+avec) ⇒ <code>object</code>
        * [.dim(args)](#g2+dim) ⇒ <code>object</code>
        * [.adim(args)](#g2+adim) ⇒ <code>object</code>
        * [.spline()](#g2+spline) ⇒ <code>object</code>
    * _static_
        * [.symbol](#g2.symbol) : <code>object</code>
        * [.flatten()](#g2.flatten)

<a name="g2+nod"></a>

### g2.nod
**Kind**: instance class of [<code>g2</code>](#g2)  
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |

<a name="new_g2+nod_new"></a>

#### new g2.prototype.nod(args)
Node symbol.


| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | symbol arguments object. |

**Example**  
```js
g2().nod({x:10,y:10})
```
<a name="g2+dblnod"></a>

### g2.dblnod
**Kind**: instance class of [<code>g2</code>](#g2)  
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |

<a name="new_g2+dblnod_new"></a>

#### new g2.prototype.dblnod()
Double nod symbol

**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | symbol arguments object. |

**Example**  
```js
g2().dblnod({x:10,y:10})
```
<a name="g2+pol"></a>

### g2.pol
**Kind**: instance class of [<code>g2</code>](#g2)  
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |

<a name="new_g2+pol_new"></a>

#### new g2.prototype.pol(args)
Pole symbol.

**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | symbol arguments object. |

**Example**  
```js
g2().pol({x:10,y:10})
```
<a name="g2+gnd"></a>

### g2.gnd
**Kind**: instance class of [<code>g2</code>](#g2)  
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |

<a name="new_g2+gnd_new"></a>

#### new g2.prototype.gnd(args)
Ground symbol.


| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | arguments object. |

**Example**  
```js
g2().gnd({x:10,y:10})
```
<a name="g2+origin"></a>

### g2.origin
**Kind**: instance class of [<code>g2</code>](#g2)  
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |
| w | <code>number</code> | angle in radians. |

<a name="new_g2+origin_new"></a>

#### new g2.prototype.origin(args)
Origin symbol

**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | symbol arguments object. |

**Example**  
```js
g2().view({cartesian:true})
    .origin({x:10,y:10})
```
<a name="g2+hdl"></a>

### g2.hdl(args) ⇒ <code>object</code>
Draw interactive handle.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | handle object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |

**Example**  
```js
g2().hdl({x:100,y:80})  // Draw handle.
```
<a name="g2+nodflt"></a>

### g2.nodflt(args) ⇒ <code>object</code>
**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | symbol arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |

**Example**  
```js
g2().view({cartesian:true})
    .nodflt({x:10,y:10})
```
<a name="g2+vec"></a>

### g2.vec(args) ⇒ <code>object</code>
Draw vector arrow.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | vector arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x1 | <code>number</code> | start x coordinate. |
| y1 | <code>number</code> | start y coordinate. |
| x2 | <code>number</code> | end x coordinate. |
| y2 | <code>number</code> | end y coordinate. |

**Example**  
```js
g2().vec({x1:50,y1:20,x2:250,y2:120})
```
<a name="g2+avec"></a>

### g2.avec(args) ⇒ <code>object</code>
Arc as Vector

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | angular dimension arguments. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| r | <code>number</code> |  | radius |
| [w] | <code>number</code> | <code>0</code> | start angle (in radian). |
| [dw] | <code>number</code> | <code>Math.PI/2</code> | angular range in radian. In case of positive values it is running counterclockwise with                                       right handed (cartesian) coordinate system. |

**Example**  
```js
g2().avec({x:100,y:70,r:50,w:pi/3,dw:4*pi/3})
```
<a name="g2+dim"></a>

### g2.dim(args) ⇒ <code>object</code>
Linear Dimension

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | dimension arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x1 | <code>number</code> |  | start x coordinate. |
| y1 | <code>number</code> |  | start y coordinate. |
| x2 | <code>number</code> |  | end x coordinate. |
| y2 | <code>number</code> |  | end y coordinate. |
| off | <code>number</code> |  | offset. |
| [inside] | <code>boolean</code> | <code>true</code> | draw dimension arrows between or outside of ticks. |

**Example**  
```js
g2().dim({x1:60,y1:40,x2:190,y2:120})
```
<a name="g2+adim"></a>

### g2.adim(args) ⇒ <code>object</code>
Angular dimension

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  
**Depricated**: <code>boolean</code> [inside] - draw dimension arrows between ticks.  

| Param | Type | Description |
| --- | --- | --- |
| args | <code>object</code> | angular dimension arguments. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| r | <code>number</code> |  | radius |
| [w] | <code>number</code> | <code>0</code> | start angle (in radian). |
| [dw] | <code>number</code> | <code>Math.PI/2</code> | angular range in radian. In case of positive values it is running counterclockwise with                                       right handed (cartesian) coordinate system. |
| [outside] | <code>boolean</code> | <code>false</code> | draw dimension arrows outside of ticks. |

**Example**  
```js
g2().adim({x:100,y:70,r:50,w:pi/3,dw:4*pi/3})
```
<a name="g2+spline"></a>

### g2.spline() ⇒ <code>object</code>
Draw spline by points.
Implementing a centripetal Catmull-Rom spline (thus avoiding cusps and self-intersections).
Using iterator function for getting points from array by index.
It must return current point object {x,y} or object {done:true}.
Default iterator expects sequence of x/y-coordinates as a flat array [x,y,...],
array of [[x,y],...] arrays or array of [{x,y},...] objects.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  
**See**

- https://pomax.github.io/bezierinfo
- https://de.wikipedia.org/wiki/Kubisch_Hermitescher_Spline


| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | spline arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> |  | array of points. |
| [closed] | <code>bool</code> | <code>false</code> | closed spline. |

**Example**  
```js
g2().spline({pts:[100,50,50,150,150,150,100,50]})
```
<a name="g2.symbol"></a>

### g2.symbol : <code>object</code>
Extended style values.
Not really meant to get overwritten. But if you actually want, proceed.<br>
These styles can be referenced using the comfortable '@' syntax.

**Kind**: static namespace of [<code>g2</code>](#g2)  
**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| symbol | <code>object</code> |  | `g2` symbol namespace. |
| [symbol.tick] | <code>object</code> |  | Predefined symbol: a little tick |
| [symbol.dot] | <code>object</code> |  | Predefined symbol: a little dot |
| [symbol.sqr] | <code>object</code> |  | Predefined symbol: a little square |
| [symbol.nodcolor] | <code>string</code> | <code>&quot;#333&quot;</code> | node color. |
| [symbol.nodfill] | <code>string</code> | <code>&quot;#dedede&quot;</code> | node fill color. |
| [symbol.nodfill2] | <code>string</code> | <code>&quot;#aeaeae&quot;</code> | alternate node fill color, somewhat darker. |
| [symbol.linkcolor] | <code>string</code> | <code>&quot;#666&quot;</code> | link color. |
| [symbol.linkfill] | <code>string</code> | <code>&quot;rgba(225,225,225,0.75)&quot;</code> | link fill color, semi-transparent. |
| [symbol.dimcolor] | <code>string</code> | <code>&quot;darkslategray&quot;</code> | dimension color. |
| [symbol.solid] | <code>array</code> | <code>[]</code> | solid line style. |
| [symbol.dash] | <code>array</code> | <code>[15,10]</code> | dashed line style. |
| [symbol.dot] | <code>array</code> | <code>[4,4]</code> | dotted line style. |
| [symbol.dashdot] | <code>array</code> | <code>[25,6.5,2,6.5]</code> | dashdotted line style. |
| [symbol.labelOffset] | <code>number</code> | <code>5</code> | default label offset distance. |
| [symbol.labelSignificantDigits] | <code>number</code> | <code>3</code> | default label's significant digits after numbering point. |

<a name="g2.flatten"></a>

### g2.flatten()
Flatten object properties (evaluate getters)

**Kind**: static method of [<code>g2</code>](#g2)  
