<a name="g2"></a>

## g2 ⇒ [<code>g2</code>](#g2)
Mechanical extensions. (Requires cartesian coordinates)

**Kind**: global typedef  
**Requires**: <code>module:g2.core.js</code>, <code>module:g2.ext.js</code>  
**Author**: Stefan Goessner  
**License**: MIT License  

* [g2](#g2) ⇒ [<code>g2</code>](#g2)
    * [.slider()](#g2+slider) ⇒ <code>object</code>
    * [.spring()](#g2+spring) ⇒ <code>object</code>
    * [.damper()](#g2+damper) ⇒ <code>object</code>
    * [.link()](#g2+link) ⇒ <code>object</code>
    * [.link2()](#g2+link2) ⇒ <code>object</code>
    * [.beam()](#g2+beam) ⇒ <code>object</code>
    * [.beam2()](#g2+beam2) ⇒ <code>object</code>
    * [.bar()](#g2+bar) ⇒ <code>object</code>
    * [.bar2()](#g2+bar2) ⇒ <code>object</code>
    * [.pulley()](#g2+pulley) ⇒ <code>object</code>
    * [.pulley2()](#g2+pulley2) ⇒ <code>object</code>
    * [.rope()](#g2+rope) ⇒ <code>object</code>
    * [.ground()](#g2+ground) ⇒ <code>object</code>
    * [.load()](#g2+load) ⇒ <code>object</code>

<a name="g2+slider"></a>

### g2.slider() ⇒ <code>object</code>
Draw slider.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | slider arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| [b] | <code>number</code> | <code>32</code> | slider breadth. |
| [h] | <code>number</code> | <code>16</code> | slider height. |
| [w] | <code>number</code> | <code>0</code> | rotation. |

**Example**  
```js
g2().slider({x:150,y:75,w:Math.PI/4,b:64,h:32})
```
<a name="g2+spring"></a>

### g2.spring() ⇒ <code>object</code>
Draw linear spring

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | linear spring arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x1 | <code>number</code> |  | start x coordinate. |
| y1 | <code>number</code> |  | start y coordinate. |
| x2 | <code>number</code> |  | end x coordinate. |
| y2 | <code>number</code> |  | end y coordinate. |
| [h] | <code>number</code> | <code>16</code> | Spring height. |

**Example**  
```js
g2().spring({x1:50,y1:100,x2:200,y2:75})
```
<a name="g2+damper"></a>

### g2.damper() ⇒ <code>object</code>
Draw line with centered square damper symbol.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | damper arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| x1 | <code>number</code> |  | start x coordinate. |
| y1 | <code>number</code> |  | start y coordinate. |
| x2 | <code>number</code> |  | end x coordinate. |
| y2 | <code>number</code> |  | end y coordinate. |
| [h] | <code>number</code> | <code>16</code> | damper height.  * g2().damper({x1:60,y1:120,x2:200,y2:75}) |

<a name="g2+link"></a>

### g2.link() ⇒ <code>object</code>
Draw polygonial link.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | link arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> |  | array of points. |
| [closed] | <code>bool</code> | <code>false</code> | closed link. |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| [w] | <code>number</code> | <code>0</code> | angle. |

**Example**  
```js
let A = {x:50,y:25},B = {x:150,y:25},
    C = {x:50,y:75}, D = {x:100,y:75},
    E = {x:50,y:125};
g2().view({cartesian:true})
    .link({pts:[A,B,E,A,D,C]})
```
<a name="g2+link2"></a>

### g2.link2() ⇒ <code>object</code>
Draw alternate glossy polygonial link.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | link2 arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> |  | array of points. |
| [closed] | <code>bool</code> | <code>false</code> | closed link. |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| [w] | <code>number</code> | <code>0</code> | angle. |

**Example**  
```js
let A = {x:50,y:25},B = {x:150,y:25},
    C = {x:50,y:75}, D = {x:100,y:75},
    E = {x:50,y:125};
g2().view({cartesian:true})
    .link({pts:[A,B,E,A,D,C]})
```
<a name="g2+beam"></a>

### g2.beam() ⇒ <code>object</code>
Draw polygonial beam.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | beam arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> |  | array of points. |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| [w] | <code>number</code> | <code>0</code> | angle. |

**Example**  
```js
g2().view({cartesian})
    .beam({pts:[[200,125][50,125][50,50][200,50]]})
```
<a name="g2+beam2"></a>

### g2.beam2() ⇒ <code>object</code>
Draw alternate glossy polygonial beam.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | beam2 arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> |  | array of points. |
| x | <code>number</code> |  | start x coordinate. |
| y | <code>number</code> |  | start y coordinate. |
| [w] | <code>number</code> | <code>0</code> | angle. |

**Example**  
```js
g2().view({cartesian})
    .beam2({pts:[[200,125][50,125][50,50][200,50]]})
```
<a name="g2+bar"></a>

### g2.bar() ⇒ <code>object</code>
Draw bar.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | bar arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x1 | <code>number</code> | start x coordinate. |
| y1 | <code>number</code> | start y coordinate. |
| x2 | <code>number</code> | end x coordinate. |
| y2 | <code>number</code> | end y coordinate. |

**Example**  
```js
g2().bar({x1:50,y1:20,x2:250,y2:120})
```
<a name="g2+bar2"></a>

### g2.bar2() ⇒ <code>object</code>
Draw alternate glossy bar.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | bar2 arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x1 | <code>number</code> | start x coordinate. |
| y1 | <code>number</code> | start y coordinate. |
| x2 | <code>number</code> | end x coordinate. |
| y2 | <code>number</code> | end y coordinate. |

**Example**  
```js
g2().bar2({x1:50,y1:20,x2:250,y2:120})
```
<a name="g2+pulley"></a>

### g2.pulley() ⇒ <code>object</code>
Draw pulley.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | pulley arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |
| r | <code>number</code> | radius. |
| w | <code>number</code> | angle. |

**Example**  
```js
g2().pulley({x:100,y:75,r:50})
```
<a name="g2+pulley2"></a>

### g2.pulley2() ⇒ <code>object</code>
Draw alternate pulley.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | pulley2 arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| x | <code>number</code> | x-value center. |
| y | <code>number</code> | y-value center. |
| r | <code>number</code> | radius. |
| w | <code>number</code> | angle. |

**Example**  
```js
g2().pulley2({x:50,y:30,r:25})
```
<a name="g2+rope"></a>

### g2.rope() ⇒ <code>object</code>
Draw rope. Amount of pulley radii must be greater than 10 units. They are forced to zero otherwise.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | rope arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| p1 | <code>object</code> \| <code>number</code> | starting point or Coordinate. |
| p2 | <code>object</code> \| <code>number</code> | end point or Coordinate. |
| r | <code>number</code> | radius of parent element. |

**Example**  
```js
let A = {x:50,y:30}, B = {x:200,y:75};
g2().view({cartesian:true})
    .pulley({...A,r:20})
    .pulley2({...B,r:40})
    .rope({p1:A,r1:20,p2:B,r2:40})
```
<a name="g2+ground"></a>

### g2.ground() ⇒ <code>object</code>
Polygon ground.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | ground arguments object. |

**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> |  | array of points. |
| [closed] | <code>bool</code> | <code>false</code> | closed polygon. |
| [h] | <code>number</code> | <code>4</code> | ground shade line width. |
| [pos] | <code>string</code> | <code>&quot;right&quot;</code> | ground shade position ['left','right']. |

**Example**  
```js
g2().ground({pts:[25,25,25,75,75,75,75,25,125,25],pos:'left'})
```
<a name="g2+load"></a>

### g2.load() ⇒ <code>object</code>
Polygonial line load. The first and last point define the base line onto which
the load is acting orthogonal.

**Kind**: instance method of [<code>g2</code>](#g2)  
**Returns**: <code>object</code> - g2  

| Param | Type | Description |
| --- | --- | --- |
|  | <code>object</code> | load arguments object. |

**Properties**

| Name | Type | Description |
| --- | --- | --- |
| pts | <code>Array.&lt;object&gt;</code> \| <code>Array.&lt;Array.&lt;number&gt;&gt;</code> \| <code>Array.&lt;number&gt;</code> | array of points. |
| w | <code>number</code> | angle of vectors. |
| spacing | <code>number</code> | spacing of the vectors drawn as a positive real number, interprete as<br>                       * spacing &lt; 1: spacing = 1/m with a partition of m.<br>                       * spacing &gt; 1: length of spacing. |

